/*
 * @package    block_enrolcode
 * @copyright  2020 Center for learning management (www.lernmanagement.at)
 * @author     Robert Schrenk
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("block_enrolcode/main",["jquery","core/ajax","core/notification","core/str","core/templates","core/url","core/modal_events","core/modal_factory","core/templates"],(function($,AJAX,NOTIFICATION,STR,TEMPLATES,URL,ModalEvents,ModalFactory,Templates){return{debug:!0,deleteCode:function(code,uniqid){STR.get_strings([{key:"confirmation",component:"block_enrolcode"},{key:"really_delete",component:"block_enrolcode",param:{code:code}}]).done((function(s){ModalFactory.create({type:ModalFactory.types.SAVE_CANCEL,title:s[0],body:s[1],large:!1}).then((function(modal){modal.getRoot().on(ModalEvents.save,(function(){modal.hide(),AJAX.call([{methodname:"block_enrolcode_delete",args:{code:code},done:function(result){"1"==result?void 0!==uniqid&&$("#block_enrolcode_old_codes-"+uniqid+" [data-code="+code+"]").remove():alert(result)},fail:NOTIFICATION.exception}])})),modal.show()}))})).fail(NOTIFICATION.exception)},fullsizeCode:function(uniqid,subid){this.debug&&console.log("block_enrolcode/main::fullsizeCode(uniqid, subid)",uniqid,subid);var enrolcode={},parentid="#enrolcode-item-"+uniqid+"-"+subid;$(parentid);["accesscode","group","maturity","enrolmentend","role"].forEach((function(field){enrolcode[field]=$(parentid+" ."+field).html()})),enrolcode.qr=$(parentid+" .qr").attr("src"),enrolcode.url=$(parentid+" .accesscode").attr("href"),STR.get_strings([{key:"code:accesscode",component:"block_enrolcode"}]).done((function(s){ModalFactory.create({type:ModalFactory.types.OK,title:s[0]+" <strong>"+enrolcode.accesscode+"</strong>",body:TEMPLATES.render("block_enrolcode/code_fullsize",enrolcode),large:!0}).then((function(modal){modal.show()}))})).fail(NOTIFICATION.exception)},generateEnrolURL:function(code){return URL.relativeUrl("/blocks/enrolcode/enrol.php?code="+code)},getCode:function(src){this.injectCSS();var MAIN=this;console.log("MAIN.getCode(src)",src);var form=$(src).closest("form"),courseid=+$(form).find('[name="courseid"]').val(),roleid=+$(form).find('[name="roleid"]').val(),groupid=+$(form).find('[name="groupid"]').val(),custommaturity=$(form).find('[name="custommaturity"]').is(":checked")?1:0,chkenrolmentend=$(form).find('[name="chkenrolmentend"]').is(":checked")?1:0,maturity=new Date($(form).find("#id_maturity_year").val(),$(form).find("#id_maturity_month").val()-1,$(form).find("#id_maturity_day").val(),$(form).find("#id_maturity_hour").val(),$(form).find("#id_maturity_minute").val(),0,0),enrolmentend=new Date($(form).find("#id_enrolmentend_year").val(),$(form).find("#id_enrolmentend_month").val()-1,$(form).find("#id_enrolmentend_day").val(),$(form).find("#id_enrolmentend_hour").val(),$(form).find("#id_enrolmentend_minute").val(),0,0),data={courseid:courseid,roleid:roleid,groupid:groupid,custommaturity:custommaturity,maturity:Math.ceil(maturity.getTime()/1e3),chkenrolmentend:chkenrolmentend,enrolmentend:Math.ceil(enrolmentend.getTime()/1e3)};STR.get_strings([{key:"code:get",component:"block_enrolcode"},{key:"finished",component:"block_enrolcode"}]).done((function(s){AJAX.call([{methodname:"block_enrolcode_get",args:data,done:function(result){var code=result;""!=result&&null!=result?(console.log("Got code",result),ModalFactory.create({type:ModalFactory.types.ALERT,title:s[0],body:Templates.render("block_enrolcode/modal_code",{code:code,qrcode_image:URL.relativeUrl("/blocks/enrolcode/pix/qr.php?format=base64&txt="+btoa(MAIN.generateEnrolURL(result))),enrolurl:MAIN.generateEnrolURL(result)}),buttons:{cancel:s[1]}}).then((function(modal){modal.show()}))):ModalFactory.create({type:ModalFactory.types.OK,title:"Error",body:TEMPLATES.render("block_enrolcode/code_get_error",{})}).then((function(modal){modal.show()}))},fail:NOTIFICATION.exception}])}))},getCodeModal:function(courseid){this.injectCSS(),AJAX.call([{methodname:"block_enrolcode_form",args:{courseid:courseid},done:function(result){STR.get_strings([{key:"code:get",component:"block_enrolcode"}]).done((function(s){ModalFactory.create({type:ModalFactory.types.OK,title:s[0],body:result,large:!0}).then((function(modal){modal.getRoot().on(ModalEvents.OK,(function(){console.log("Hiding modal"),modal.hide()})),modal.show()}))})).fail(NOTIFICATION.exception)},fail:NOTIFICATION.exception}])},injectButton:function(courseid){void 0===courseid||courseid<=1||STR.get_strings([{key:"code:get",component:"block_enrolcode"}]).done((function(s){$("#page-content div.enrolusersbutton").parent().prepend($('<div class="singlebutton enrolusersbutton block_enrolcode">').append($('<a href="#" onclick="require([\'block_enrolcode/main\'], function(MAIN) { MAIN.getCodeModal('+courseid+'); }); return false;" class="btn btn-secondary my-1">'+s[0]+"</a>")))})).fail(NOTIFICATION.exception)},injectCSS:function(){0==$('head>link[href$="/blocks/enrolcode/style/enrolcode.css"]').length&&(console.log("Adding CSS File ",URL.relativeUrl("/blocks/enrolcode/style/enrolcode.css")),$("head").append($('<link rel="stylesheet" type="text/css" href="'+URL.relativeUrl("/blocks/enrolcode/style/enrolcode.css")+'">')))},injectMainmenuButton:function(){STR.get_strings([{key:"code:accesscode",component:"block_enrolcode"}]).done((function(s){$('.usermenu .dropdown a[href$="/user/preferences.php"]').after($("<a>").attr("href","#").attr("onclick","require(['block_enrolcode/main'], function(MAIN) { MAIN.sendCodeModal(); }); return false;").addClass("dropdown-item menu-action").attr("role","menuitem").attr("data-title","moodle,accesscard").attr("aria-labelledby","actionmenuaction-accesscard").attr("data-ajax","false").append([$("<i>").addClass("icon fa fa-key fa-fw").attr("aria-hidden","true"),$("<span>").addClass("menu-action-text").attr("id","actionmenuaction-accesscard").html(s[0])]))})).fail(NOTIFICATION.exception)},revokeCode:function(code){this.injectCSS();console.log("MAIN.revokeCode(code)",code),AJAX.call([{methodname:"block_enrolcode_revoke",args:{code:code},done:function(result){},fail:NOTIFICATION.exception}])},sendCode:function(uniqid,code){this.injectCSS();console.log("MAIN.sendCode(uniqid, code)",uniqid,code),void 0!==uniqid&&""!=uniqid&&(code=$("#code-"+uniqid).val()),AJAX.call([{methodname:"block_enrolcode_send",args:{code:code},done:function(result){console.log("Got courseid ",result),result>1?top.location.href=URL.relativeUrl("/course/view.php?id="+result,{}):ModalFactory.create({type:ModalFactory.types.OK,title:"Error",body:"Invalid code"}).then((function(modal){modal.show()}))},fail:NOTIFICATION.exception}])},sendCodeModal:function(){var MAIN=this;this.injectCSS(),STR.get_strings([{key:"code:get",component:"block_enrolcode"},{key:"finished",component:"block_enrolcode"}]).done((function(s){ModalFactory.create({type:ModalFactory.types.SAVE_CANCEL,title:s[0],body:Templates.render("block_enrolcode/modal_enter",{}),buttons:{save:s[1]}}).then((function(modal){modal.show();var root=modal.getRoot();root.on(ModalEvents.save,(function(){var code=$(root).find("#code").val();MAIN.sendCode("",code)}))}))}))},shareCode:function(src){console.log("MAIN.shareCode(src)",src);var target=$(src).attr("data-target"),code=$(src).closest(".container").find("#code").html(),enrolurl=MAIN.generateEnrolURL(code);if("facebook"===target)window.open("https://www.facebook.com/sharer.php?u="+encodeURI(enrolurl))}}}));

//# sourceMappingURL=main.min.js.map